

#include <reg52.h>
#include <intrins.h>

sbit SCK=P3^6;		
sbit SDA=P3^4;		
sbit RST = P3^5;   // DS1302λ

bit ReadRTC_Flag;

unsigned char l_tmpdate[7]={0,0,12,15,5,3,8};//ʱ08-05-15 12:00:00
unsigned char l_tmpdisplay[8];
code unsigned char write_rtc_address[7]={0x80,0x82,0x84,0x86,0x88,0x8a,0x8c}; //ʱ λдλ
code unsigned char read_rtc_address[7]={0x81,0x83,0x85,0x87,0x89,0x8b,0x8d};  

code unsigned char table[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f,0x40}; 
			         // 0-9  '-' 'Ϩ𡮱
code unsigned char table1[]={0,1,2,3,4,5,6,7};
                     //ʾλ

												
void Write_Ds1302_byte(unsigned char temp); 
void Write_Ds1302( unsigned char address,unsigned char dat );
unsigned char Read_Ds1302 ( unsigned char address );

void Read_RTC(void);//read RTC 
void Set_RTC(void); //set RTC 

void InitTIMER0(void);//inital timer0

void main(void)    
{
    InitTIMER0();
 	Set_RTC();
	while(1){
	 if(ReadRTC_Flag)
	 {
	    ReadRTC_Flag=0;
		Read_RTC();
		switch (l_tmpdate[0]/5)   //ÿ5 ʾ  ʱ
		{
		case 0:
		case 2:
		case 4:
		case 6:
		case 8:
		case 10:
			l_tmpdisplay[0]=l_tmpdate[2]/16;			//ݵתǲ0~9ʾ,ݷֿ
			l_tmpdisplay[1]=l_tmpdate[2]&0x0f;
			l_tmpdisplay[2]=10;					    	//"-"
			l_tmpdisplay[3]=l_tmpdate[1]/16;
			l_tmpdisplay[4]=l_tmpdate[1]&0x0f;
			l_tmpdisplay[5]=10;
			l_tmpdisplay[6]=l_tmpdate[0]/16;
			l_tmpdisplay[7]=l_tmpdate[0]&0x0f;	
			break;
		case 1:
		case 3:
		case 5:
		case 7:
		case 9:
		case 11:
			l_tmpdisplay[0]=l_tmpdate[6]/16;
			l_tmpdisplay[1]=l_tmpdate[6]&0x0f;
			l_tmpdisplay[2]=10;
			l_tmpdisplay[3]=l_tmpdate[4]/16;
			l_tmpdisplay[4]=l_tmpdate[4]&0x0f;
			l_tmpdisplay[5]=10;
			l_tmpdisplay[6]=l_tmpdate[3]/16;
			l_tmpdisplay[7]=l_tmpdate[3]&0x0f;
			break;
		default:
			break;
		}
	
	 }
	}
}

void InitTIMER0(void)
{
 TMOD|=0x01;//ʱ 16λ
 TH0=0xef;//ʼֵ
 TL0=0xf0;
 ET0=1;
 TR0=1;
 EA=1;
}



void Write_Ds1302_Byte(unsigned  char temp) 
{
 unsigned char i;
 for (i=0;i<8;i++)     	//ѭ8 д
  { 
   SCK=0;
     SDA=temp&0x01;     	//ÿδֽ 
     temp>>=1;  		//һλ
     SCK=1;
   }
}   

/****************************************************************************/
void Write_Ds1302( unsigned char address,unsigned char dat )     
{
 	RST=0;
	_nop_();
 	SCK=0;
	_nop_();
 	RST=1;	
   	_nop_();   //
 	Write_Ds1302_Byte(address);	//͵ַ
 	Write_Ds1302_Byte(dat);		//
 	RST=0;  		//ָ
}
/****************************************************************************/
unsigned char Read_Ds1302 ( unsigned char address )
{
 	unsigned char i,temp=0x00;
 	RST=0;
	_nop_();
 	SCK=0;
	_nop_();
 	RST=1;
	_nop_();
 	Write_Ds1302_Byte(address);
 	for (i=0;i<8;i++) 		//ѭ8 ȡ
 	{		
 		if(SDA)
 		temp|=0x80;			//ÿδֽ
		SCK=0;
		temp>>=1;			//һλ
 		SCK=1;
	} 
 	RST=0;
	_nop_();		//ΪDS1302λȶʱ
 	RST=0;
	SCK=0;
	_nop_();
	SCK=1;
	_nop_();
	SDA=0;
	_nop_();
	SDA=1;
	_nop_();
	return (temp);			//
}
/****************************************************************************/
void Read_RTC(void)		//ȡ 
{
 unsigned char i,*p;
 p=read_rtc_address; 	//ַ
 for(i=0;i<7;i++)		//7ζȡ ʱ
 {
  l_tmpdate[i]=Read_Ds1302(*p);
  p++;
 }
}
/***********************************************************************/
void Set_RTC(void)		//趨 
{
	unsigned char i,*p,tmp;
	for(i=0;i<7;i++){           //BCD
		tmp=l_tmpdate[i]/10;
		l_tmpdate[i]=l_tmpdate[i]%10;
		l_tmpdate[i]=l_tmpdate[i]+tmp*16;
	}
 	Write_Ds1302(0x8E,0X00);
	
 	p=write_rtc_address;	//ַ	
 	for(i=0;i<7;i++)		//7д ʱ
 	{
		  Write_Ds1302(*p,l_tmpdate[i]);
 		 p++;  
	 }
	 Write_Ds1302(0x8E,0x80);
}

void tim(void) interrupt 1 using 1//жϣɨ
{

    static unsigned char i,num;
    TH0=0xf5;
    TL0=0xe0;

 	P0=table[l_tmpdisplay[i]];		//õҪʾֵ
	P2=table1[i];
	i++;
	if(i==8)
	  {
	   i=0;
	   num++;
	   if(10==num)       //ʱȡ1302ݡʱԵ
	     {
		 ReadRTC_Flag=1; //ʹñ־λж
		 num=0;
		 }
	   
	   }
 }


